/*
Simpson Integrator calculates the integral of f(x) from x0 to x1 using 
quadratic Simpson approximation. The amount of nodes is n.
*/


#include <math.h>

double simpson(double f(double x),double x0,double x1,unsigned long n)
{
unsigned long m,nn;
double h,s,k=4.0;

if(n<4) n=4;     // 4 nodes at minimum

n&=0xfffffffeLU; // even number of nodes

nn=n-1;

h=(x1-x0)/((double)n);

s=f(x0)+f(x1);

for(m=1;m<=nn;m++)
 {
 s+=k*f(x0+((double)m)*h);
 k=6.0-k;
 }

return s*h/3.0;

}
